django_project/urls.py
from django.conf import settings
from django.urls import path
from django.urls import include
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.views.generic import TemplateView
from django.conf.urls.static import static

urlpatterns = [
    path("admin/", admin.site.urls),
    path(
        "",
        TemplateView.as_view(template_name="home.html"),
        name="home",
    ),
    path(
        "team/",
        TemplateView.as_view(template_name="team.html"),
        name="team",
    ),
    path(
        "about/",
        TemplateView.as_view(template_name="about.html"),
        name="about",
    ),
    path("accounts/", include("users.urls")),
    path("accounts/", include("user_profile.urls")),
]

urlpatterns += [
    path(
        "accounts/password_change/",
        auth_views.PasswordChangeView.as_view(
            template_name="registration/password_change.html",
        ),
        name="password_change",
    ),
    path(
        "accounts/password_change/done/",
        auth_views.PasswordChangeDoneView.as_view(
            template_name="registration/password_change_done.html",
        ),
        name="password_change_done",
    ),
    path(
        "accounts/login/",
        auth_views.LoginView.as_view(
            template_name="registration/login.html",
        ),
        name="login",
    ),
    path(
        "accounts/logout/",
        auth_views.LogoutView.as_view(
            template_name="registration/logout.html",
        ),
        name="logout",
    ),
    path(
        "accounts/password_reset/",
        auth_views.PasswordResetView.as_view(
            template_name="registration/password_reset.html",
        ),
        name="password_reset",
    ),
    path(
        "accounts/password_reset/done/",
        auth_views.PasswordResetDoneView.as_view(
            template_name="registration/password_reset_done.html",
        ),
        name="password_reset_done",
    ),
    path(
        "accounts/reset/<uidb64>/<token>/",
        auth_views.PasswordResetConfirmView.as_view(
            template_name="registration/password_reset_confirm.html",
        ),
        name="password_reset_confirm",
    ),
    path(
        "accounts/reset/done/",
        auth_views.PasswordResetCompleteView.as_view(
            template_name="registration/password_reset_complete.html",
        ),
        name="password_reset_complete",
    ),
]

urlpatterns += static(
    settings.STATIC_URL,
    document_root=settings.STATIC_ROOT,
)
urlpatterns += static(
    settings.MEDIA_URL,
    document_root=settings.MEDIA_ROOT,
)

user_profile/urls.py
"""User profile app URL."""

from django.urls import path

from . import views

app_name = "user_profile"

urlpatterns = [
    path(
        "profile/",
        views.UserProfileDetailView.as_view(),
        name="profile_detail",
    ),
    path(
        "profile/update/",
        views.UserProfileUpdateView.as_view(),
        name="profile_update",
    ),
]

users/urls.py
"""Accounts app URL Configuration."""

from django.urls import path

from users import views as users_views

app_name = "users"

urlpatterns = [
    path(
        "signup/",
        users_views.SignUpView.as_view(),
        name="signup",
    ),
]

users/models.py
"""Accounts models."""

from django.db import models
from django.utils.translation import gettext_lazy as _
from django.contrib.auth.models import AbstractUser

from users.managers import CustomUserManager


class CustomUser(AbstractUser):
    """A custom User model.

    Arguments:
    ---------
    AbstractUser : class
        Django's `AbstractUser` class.

    Returns:
    -------
    object:
        `CustomUser` model.

    """

    username = None
    email = models.EmailField(_("email address"), unique=True)

    USERNAME_FIELD = "email"
    REQUIRED_FIELDS = []

    objects = CustomUserManager()

    def __str__(self) -> str:
        """Get the string representation of the object.

        Returns
        -------
        str
            The unique identifier of the model, `email`.

        """
        return self.email

users/forms.py
"""Forms for accounts app."""

from django.contrib.auth.forms import UserChangeForm
from django.contrib.auth.forms import UserCreationForm

from users.models import CustomUser


class CustomUserCreationForm(UserCreationForm):
    """Registration form."""

    class Meta:
        """Meta class."""

        model = CustomUser
        fields = (
            "first_name",
            "last_name",
            "email",
            "password1",
            "password2",
        )


class CustomUserChangeForm(UserChangeForm):
    """User profile change view."""

    class Meta:
        """Meta class."""

        model = CustomUser
        fields = (
            "first_name",
            "last_name",
            "email",
        )

users/views.py
"""Accounts view."""

from django.urls import reverse_lazy
from django.views.generic import CreateView

from users.forms import CustomUserCreationForm
from users.models import CustomUser


class SignUpView(CreateView):
    """User registration view."""

    model = CustomUser
    form_class = CustomUserCreationForm
    template_name = "generic_create_update_form.html"
    success_url = reverse_lazy("login")
    extra_context = {
        "title_text": "Sign Up",
        "button_text": "Register",
    }

users/templates/about.html
{% extends "base_generic.html" %}
{% block title %}
    About Project
{% endblock title %}
{% block content %}
    <div class="container py-5">
        <p>Add a description about your project</p>
        <p>
            Feel free to change the style and beautify the page using
            <a href="https://getbootstrap.com" target="_blank">Bootstrap</a>
        </p>
    </div>
{% endblock content %}

users/templates/base_generic.html
{# Load the tag library #}
{% load django_bootstrap5 %}
{% load static %}
<!DOCTYPE html>
<html lang="us-en">
    <head>
        <meta charset="UTF-8" />
        <meta name="description" content="Django Project Template" />
        <meta name="keywords" content="HTML, CSS, JavaScript" />
        <meta name="author" content="John Doe" />
        <meta name="viewport" content="width=device-width, initial-scale=1.0" />
        <link rel="shortcut icon"
              type="image/png"
              href="{% static 'img/favicon.ico' %}"/>
        <title>Django Project Template</title>
        {# Load CSS and JavaScript #}
        {% bootstrap_css %}
        {% bootstrap_javascript %}
        {# Display django.contrib.messages as Bootstrap alerts #}
        {% bootstrap_messages %}
        <link rel="stylesheet" href="{% static 'css/base.css' %}" />
        <link href="{% static 'fontawesomefree/css/all.min.css' %}"
              rel="stylesheet"
              type="text/css"/>
        {% block style %}
        {% endblock style %}
    </head>
    <body>
        {% include "navbar.html" %}
        <div class="container">
            <h1 class="text-center fw-bold mb-5">
                {% block title %}
                {% endblock title %}
            </h1>
            {% block content %}
            {% endblock content %}
        </div>
        {% include "footer.html" %}
    </body>
</html>

users/templates/footer.html
<footer class="footer pt-3 mt-4 text-muted">
    <div class="container">
        Django Project template is powered by
        <a target="_blank" href="https://getbootstrap.com/">Bootstrap</a>
        and
        <a target="_blank" href="https://fontawesome.com/">Font awesome</a>.
    </div>
</footer>

users/templates/generic_confirm_delete.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    {{ title_text }}
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center">
        <div class="col-md-4">
            <form method="post">
                {% csrf_token %}
                <p>Are you sure you want to delete "{{ object }}"?</p>
                {% bootstrap_form form %}
                {{ form.media }}
                <div class="text-center">
                    <button type="submit" class="btn btn-danger">Confirm</button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}

users/templates/generic_create_update_form.html
{% extends "base_generic.html" %}
{% load django_bootstrap5 %}
{% block title %}
    {{ title_text }}
{% endblock title %}
{% block content %}
    <div class="d-flex justify-content-center">
        <div class="col-md-4">
            <form method="post" enctype="multipart/form-data">
                {% csrf_token %}
                {% bootstrap_form form %}
                {{ form.media }}
                <div class="text-center">
                    <button type="submit" class="btn btn-primary">{{ button_text }}</button>
                </div>
            </form>
        </div>
    </div>
{% endblock content %}

users/templates/home.html
{% extends "base_generic.html" %}
{% block content %}
    <!-- Main jumbotron for a primary marketing message or call to action -->
    <div class="p-5 mb-4 bg-light rounded-3">
        <div class="py-5">
            <h1 class="display-3 fw-bold">Insert Project Title Here</h1>
            <p>Insert a short description of your project here.</p>
            <p class="col-md-8 fs-4">
                <a class="btn btn-primary btn-lg" href="{% url 'about' %}" role="button">Learn more</a>
            </p>
        </div>
    </div>
    <div class="py-5">
        <div class="row align-items-md-stretch">
            <div class="col-md-6">
                <div class="h-100 p-5 bg-light rounded-3">
                    <p>Use this space to add any additional information about the project</p>
                </div>
            </div>
            <div class="col-md-6">
                <div class="h-100 p-5 bg-light rounded-3">
                    <p>Use this space to add any additional information about the project.</p>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

users/templates/navbar.html
{% load django_bootstrap5 %}
{% load static %}
<nav class="navbar navbar-expand-md navbar-dark fixed-top bg-dark justify-content-between">
    <div class="container">
        <a class="navbar-brand" href="{% url 'home' %}">
            <i class="fa-solid fa-house"></i> Product
        </a>
        <button class="navbar-toggler"
                type="button"
                data-toggle="collapse"
                data-target="#navbarsExampleDefault"
                aria-controls="navbarsExampleDefault"
                aria-expanded="false"
                aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="#navbarsExampleDefault">
            <ul class="navbar-nav mr-auto">
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'about' %}">
                        <i class="fa-solid fa-circle-info"></i> About
                    </a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="{% url 'team' %}">
                        <i class="fa-solid fa-people-group"></i> Team
                    </a>
                </li>
            </ul>
        </div>
        <div class="navbar-collapse collapse" id="#navbarsExampleDefault">
            <ul class="navbar-nav ms-auto mb-2 mb-lg-0">
                {% if user.is_authenticated %}
                    <div class="dropdown">
                        <a class="nav-link dropdown-toggle"
                           role="button"
                           data-toggle="dropdown"
                           data-bs-toggle="dropdown"
                           aria-expanded="false">
                            {% if user.picture %}
                                <img src="{{ user.picture.url }}"
                                     alt="Profile Picture"
                                     class="rounded-circle img-thumbnail"
                                     height="30"
                                     width="30">
                            {% else %}
                                <img src="{% static 'img/user-icon.png' %}"
                                     alt="Profile Picture"
                                     class="rounded-circle img-thumbnail"
                                     height="30"
                                     width="30">
                            {% endif %}
                            {{ user.email }}
                        </a>
                        <ul class="dropdown-menu">
                            <li>
                                <a class="dropdown-item" href="{% url 'user_profile:profile_detail' %}">
                                    <i class="fa-solid fa-user-cog"></i> Profile
                                </a>
                            </li>
                            <li>
                                <div class="dropdown-divider"></div>
                            </li>
                            <li>
                                <form method="post" action="{% url 'logout' %}">
                                    {% csrf_token %}
                                    <button type="submit" class="dropdown-item">
                                        <i class="fa-solid fa-sign-out-alt"></i> Log out
                                    </button>
                                </form>
                            </li>
                        </ul>
                    </div>
                {% else %}
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'login' %}">
                            <i class="fa-solid fa-sign-in"></i> Sign in
                        </a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="{% url 'users:signup' %}">
                            <i class="fa-solid fa-user-edit"></i> Sign up
                        </a>
                    </li>
                {% endif %}
            </ul>
        </div>
    </div>
</nav>

users/templates/team.html
{% extends "base_generic.html" %}
{% load static %}
{% block style %}
{% endblock style %}
{% block title %}
    Meet our team
{% endblock title %}
{% block content %}
    <div class="justify-content-center">
        <div class="text-center d-flex">
            <div class="col-md-3 col-sm-6 mb-4">
                <i class="fa-regular fa-circle-user fa-8x mb-2"></i>
                <!-- Replace 'Name' with the Project Lead's name -->
                <h4 class="fw-bold">Name</h4>
                <p class="fw-bold">Project Lead</p>
                <!-- Update hrefs with the URLs to email, linked, and gitlab -->
                <a href="#" target="_blank"><i class="fa-solid fa-envelope"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-linkedin"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-gitlab"></i></a>
            </div>
            <div class="col-md-3 col-sm-6 mb-4">
                <i class="fa-regular fa-circle-user fa-8x mb-2"></i>
                <!-- Replace 'Name' with the Tech Lead's name -->
                <h4 class="fw-bold">Name</h4>
                <p class="fw-bold">Tech Lead</p>
                <!-- Update hrefs with the URLs to email, linked, and gitlab -->
                <a href="#" target="_blank"><i class="fa-solid fa-envelope"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-linkedin"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-gitlab"></i></a>
            </div>
            <div class="col-md-3 col-sm-6 mb-4">
                <i class="fa-regular fa-circle-user fa-8x mb-2"></i>
                <!-- Replace 'Name' with the Product Lead's name -->
                <h4 class="fw-bold">Name</h4>
                <p class="fw-bold">Product Lead</p>
                <!-- Update hrefs with the URLs to email, linked, and gitlab -->
                <a href="#" target="_blank"><i class="fa-solid fa-envelope"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-linkedin"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-gitlab"></i></a>
            </div>
            <div class="col-md-3 col-sm-6 mb-4">
                <i class="fa-regular fa-circle-user fa-8x mb-2"></i>
                <!-- Replace 'Name' with the QA's name -->
                <h4 class="fw-bold">Name</h4>
                <p class="fw-bold">Quality Assurance</p>
                <!-- Update hrefs with the URLs to email, linked, and gitlab -->
                <a href="#" target="_blank"><i class="fa-solid fa-envelope"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-linkedin"></i></a> |
                <a href="#" target="_blank"><i class="fa-brands fa-gitlab"></i></a>
            </div>
        </div>
    </div>
{% endblock content %}